addHook("PlayerSpawn", function(player)
	if player.valid and player.mo and player.mo.valid
		if player.mo.skin == "engineertf2"
			if not player.wasengineer
				player.nowengineertimer = 3
			end
			player.wasengineer = true
		elseif player.wasengineer
			player.wasengineertimer = 3
			player.wasengineer = false
		end
	end
end)

addHook("PlayerThink", function(player) //Player think
	if player.valid
		player.wasengineertimer = $ or 0
		player.nowengineertimer = $ or 0
		if player.wasengineertimer then player.wasengineertimer = max($-1,0) end
		if player.nowengineertimer then player.nowengineertimer = max($-1,0) end
		
		if player.mo and player.mo.valid
			if player.mo.skin == "engineertf2"
				if not player.wasengineer
					player.nowengineertimer = 3
				end
				player.wasengineer = true
			else
				if player.wasengineer
					player.wasengineertimer = 3
					player.wasengineer = false
				end
			end
		end
	end
end)

hud.add(function(v,player,cam)
	if player.valid
	and not player.spectator and player.mo
	and player.mo.valid
		if player.mo.skin == "engineertf2"
			//Score hud
			local scorebg = v.cachePatch("HTF_SCORE")
			v.drawScaled(hudinfo[HUD_SCORE].x*FRACUNIT,hudinfo[HUD_SCORE].y*FRACUNIT,
				FRACUNIT/2,
				scorebg,V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS|V_PERPLAYER,
				v.getColormap(player.mo.skin,player.skincolor))
			
			--Score numbers
			local scorenum = "TF2F"
			local score = player.score
			local prevw
			if not prevw then prevw = 0 end
			for i = 1,string.len(score)
				local n = string.sub(score,i,i)
				v.drawScaled((hudinfo[HUD_SCORE].x+8+prevw)*FRACUNIT,(hudinfo[HUD_SCORE].y+12)*FRACUNIT,
					FRACUNIT/2,
					v.cachePatch(scorenum+n),V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS|V_PERPLAYER,v.getColormap("sonic",SKINCOLOR_WHITE))
					
				prevw = $+v.cachePatch(scorenum+n).width/2
			end
			
			//Lives+Rings HUD
			local classbg = v.cachePatch("HTF_CLASSBG")
			--Lives
			v.draw(hudinfo[HUD_LIVES].x+classbg.width/7*3, hudinfo[HUD_LIVES].y+16,v.cachePatch("STLIVEX"),V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS|V_PERPLAYER)
			local lives = (player.lives == INFLIVES and "\x16") or player.lives
			v.drawString(hudinfo[HUD_LIVES].x+classbg.width/7*3+8, hudinfo[HUD_LIVES].y+14,lives,V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS|V_PERPLAYER)
			
			--Class background
			v.drawScaled(hudinfo[HUD_LIVES].x*FRACUNIT,hudinfo[HUD_LIVES].y*FRACUNIT,
				FRACUNIT/2,
				classbg,V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS|V_PERPLAYER,
				v.getColormap(player.mo.skin,player.skincolor))
				
			--Class portrait
			local class = v.cachePatch("HTF_ENGI")
			v.drawScaled(hudinfo[HUD_LIVES].x*FRACUNIT,(hudinfo[HUD_LIVES].y+21)*FRACUNIT,
				FRACUNIT/4,
				class,V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS|V_PERPLAYER,
				v.getColormap(player.mo.skin,player.skincolor))
				
				
			--Rings
			local hpbg = v.cachePatch("HTF_HPBG")
			local hpfill = v.cachePatch("HTF_HPFULL")
			local hpover = v.cachePatch("HTF_HPOVER")
			
			--"Overheal"
			if player.rings > 125
				v.drawScaled((hudinfo[HUD_LIVES].x+classbg.width/4+16)*FRACUNIT,(hudinfo[HUD_LIVES].y-10)*FRACUNIT-(FRACUNIT/2),
					((FRACUNIT/125)/4)*min(player.rings,185),hpover,V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANSHALF|V_PERPLAYER)
			end
			
			v.drawScaled((hudinfo[HUD_LIVES].x+classbg.width/4)*FRACUNIT,(hudinfo[HUD_LIVES].y-26)*FRACUNIT,
				FRACUNIT/4,hpbg,V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS|V_PERPLAYER)
			
			local invperc = FRACUNIT - FixedDiv(min(player.rings,125)*FRACUNIT, 125*FRACUNIT)
			v.drawCropped(
				(hudinfo[HUD_LIVES].x+classbg.width/4)*FRACUNIT,(hudinfo[HUD_LIVES].y-26)*FRACUNIT
					+abs(FixedMul(128*FRACUNIT/4, invperc)),FRACUNIT/4, FRACUNIT/4,
				
				hpfill,V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS,nil,
				0, abs(FixedMul(128*FRACUNIT, invperc)),
				128*FRACUNIT, 128*FRACUNIT)
				
			--Rings counter
			local c = ((player.rings <= 0) and leveltime/5&1) and V_REDMAP or 0
			v.drawString(hudinfo[HUD_LIVES].x+classbg.width/4+16,hudinfo[HUD_LIVES].y-14,
				player.rings,V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS|V_PERPLAYER|c,"center")
		end
		
		//Some stuff
		local deftimey = 26
		local timeaddx = 116
		if player.nowengineertimer
			hud.disable("rings")
			hud.disable("lives")
			hud.disable("score")
			
			hudinfo[HUD_TIME].y = 			-16
			
			hudinfo[HUD_MINUTES].y = 		hudinfo[HUD_SCORE].y
			hudinfo[HUD_TIMECOLON].y = 		hudinfo[HUD_SCORE].y
			hudinfo[HUD_SECONDS].y = 		hudinfo[HUD_SCORE].y
			hudinfo[HUD_TIMETICCOLON].y = 	hudinfo[HUD_SCORE].y
			hudinfo[HUD_TICS].y = 			hudinfo[HUD_SCORE].y
			
			hudinfo[HUD_MINUTES].x = 188
			hudinfo[HUD_TIMECOLON].x = 188
			hudinfo[HUD_SECONDS].x = 212
			hudinfo[HUD_TIMETICCOLON].x = 212
			hudinfo[HUD_TICS].x = 236
		end
		if player.wasengineertimer
			hud.enable("rings")
			hud.enable("lives")
			hud.enable("score")
			
			hudinfo[HUD_TIME].y = 			deftimey
			
			hudinfo[HUD_MINUTES].y = 		deftimey
			hudinfo[HUD_TIMECOLON].y = 		deftimey
			hudinfo[HUD_SECONDS].y = 		deftimey
			hudinfo[HUD_TIMETICCOLON].y = 	deftimey
			hudinfo[HUD_TICS].y = 			deftimey
			
			hudinfo[HUD_MINUTES].x = 72
			hudinfo[HUD_TIMECOLON].x = 72
			hudinfo[HUD_SECONDS].x = -20
			hudinfo[HUD_TIMETICCOLON].x = -20
			hudinfo[HUD_TICS].x = 4
		end
	end
end,"game")